export declare const BACK = "Navigation/BACK";
export declare const INIT = "Navigation/INIT";
export declare const NAVIGATE = "Navigation/NAVIGATE";
export declare const SET_PARAMS = "Navigation/SET_PARAMS";
export declare const POP = "Navigation/POP";
export declare const POP_TO_TOP = "Navigation/POP_TO_TOP";
export declare const PUSH = "Navigation/PUSH";
export declare const RESET = "Navigation/RESET";
export declare const REPLACE = "Navigation/REPLACE";
export declare type BackParams = {
    key?: string;
};
export declare type BackAction = {
    type: typeof BACK;
    payload: BackParams;
};
export declare type InitParams = {
    params?: any;
};
export declare type InitAction = {
    type: typeof INIT;
    payload: InitParams;
};
export declare type NavigateParams = {
    routeName: string;
    params?: any;
    action?: RouterActions;
    key?: string;
};
export declare type NavigateAction = {
    type: typeof NAVIGATE;
    payload: NavigateParams;
};
export declare type SetParamsParams = {
    key?: string;
    params?: any;
    preserveFocus: boolean;
};
export declare type SetParamsAction = {
    type: typeof SET_PARAMS;
    payload: SetParamsParams;
};
export declare type PopParams = {
    n?: number;
};
export declare type PopAction = {
    type: typeof POP;
    payload: PopParams;
};
export declare type PopToTopAction = {
    type: typeof POP_TO_TOP;
};
export declare type PushParams = {
    routeName: string;
    params?: any;
    action?: RouterActions;
};
export declare type PushAction = {
    type: typeof PUSH;
    payload: PushParams;
};
export declare type ResetParams = {
    index: number;
    actions: RouterActions[];
    key?: string | null;
};
export declare type ResetAction = {
    type: typeof RESET;
    payload: ResetParams;
};
export declare type ReplaceParams = {
    key?: string;
    newKey?: string;
    routeName?: string;
    params?: object;
    action?: RouterActions;
};
export declare type ReplaceAction = {
    type: typeof REPLACE;
    payload: ReplaceParams;
};
export declare type NavigationActions = NavigateAction | BackAction | SetParamsAction | InitAction;
export declare type StackActions = ResetAction | ReplaceAction | PushAction | PopAction | PopToTopAction;
export declare type RouterActions = NavigationActions | StackActions;
