import { RouterReducer, RouterState, RouteableState, MountableNode, Resolver } from "./routeable";
import { RouterActions, NavigateParams, PopParams } from "./actions/types";
import { PublicRoute } from "./public-route";
export declare type MountedNodeSet = {
    [key: string]: MountedNode;
};
export declare class MountedNode implements MountableNode {
    childNodes: MountedNodeSet;
    routeableState?: RouteableState;
    componentName: string;
    route: PublicRoute;
    key: string;
    id: number;
    header?: any;
    mountedRouter: MountedRouter;
    constructor(mountedRouter: MountedRouter, routeableState: RouteableState);
    update(routeableState: RouteableState): void;
    unmount(): void;
    resolve(name: string): typeof PublicRoute | null;
    getHeaderConfig(): any;
}
export default class MountedRouter {
    router: RouterReducer;
    state: RouterState;
    resolver: Resolver;
    rootNode: MountedNode;
    constructor(router: RouterReducer, resolver: Resolver);
    dispatch(action: RouterActions): void;
    _sendEvents(): void;
    _update(): void;
    navigate(options: NavigateParams): void;
    pop(options: PopParams): void;
}
