import { RouteReducer, RouteableReducer, RouteState, RouterState, UnhandledReducerResult, InitialStateOptions } from "./routeable";
import { RouterActions } from "./actions/types";
import { MountedNode } from "./mounted-router";
export declare type RouteOptions = {
    componentName?: string;
};
export declare class Route implements RouteReducer {
    name: string;
    children: RouteableReducer[];
    options: RouteOptions;
    isRouter: false;
    componentName: string;
    constructor(name: string, options: RouteOptions);
    getInitialState(options?: InitialStateOptions): RouteState;
    dispatch(_action: RouterActions, _state: RouterState): UnhandledReducerResult;
    reconcile(routeState: RouteState, mountedNode: MountedNode): void;
}
