import { RouteableReducer, RouterReducer, RouteState, ReducerResult, RouterState } from "../routeable";
import { RouterActions } from "../actions/types";
export interface BaseOptions {
    componentName?: string;
}
export declare function handledAction(state: RouterState): ReducerResult;
export declare function unhandledAction(): ReducerResult;
export declare class BaseRouter {
    name: string;
    children: RouteableReducer[];
    componentName: string;
    isRouter: true;
    childRouteables: {
        [k: string]: RouteableReducer;
    };
    options: BaseOptions;
    routeNames: string[];
    constructor(name: string, children: RouteableReducer[], options: BaseOptions);
    childRouterNamed(name: string): RouterReducer | null;
    dispatchTo(routeStates: RouteState[], action: RouterActions): RouterState | void;
}
