import { NavigateAction, RouterActions, PopAction, BackAction } from "../actions/types";
import { RouterReducer, RouterState, ReducerResult, InitialStateOptions, StackRouterState } from "../routeable";
import { BaseRouter, BaseOptions } from "./base-router";
import { MountedNode } from "../mounted-router";
export interface StackOptions extends BaseOptions {
    headerComponentName?: string;
    headerMode?: string;
}
export declare class StackRouter extends BaseRouter implements RouterReducer {
    dispatch(action: RouterActions, state: RouterState): ReducerResult;
    navigate(action: NavigateAction, state: RouterState): ReducerResult;
    delegateNavigationToActiveChildRouters(action: NavigateAction, state: RouterState): ReducerResult | void;
    navigateToPreexisting(action: NavigateAction, state: RouterState): ReducerResult | void;
    navigateToNew(action: NavigateAction, state: RouterState): ReducerResult | void;
    goBack(action: BackAction, _state: RouterState): ReducerResult;
    popStack(action: PopAction, state: RouterState): ReducerResult;
    getInitialState(options?: InitialStateOptions): StackRouterState;
    reconcile(routerState: RouterState, mountedNode: MountedNode): void;
}
