import { RouteableReducer, RouterReducer, RouterState, RouteableState, InitialStateOptions, ReducerResult } from "../routeable";
import { BaseRouter, BaseOptions } from "./base-router";
import { RouterActions, NavigateAction } from "../actions/types";
import { MountedNode } from "../mounted-router";
export interface SwitchOptions extends BaseOptions {
}
export declare class SwitchRouter extends BaseRouter implements RouterReducer {
    dispatch(action: RouterActions, state: RouterState): ReducerResult;
    navigate(action: NavigateAction, state: RouterState): ReducerResult;
    navigateAway(action: NavigateAction, state: RouterState): ReducerResult;
    switchToRoute(state: RouterState, childRouteState: RouteableState, i: number): ReducerResult;
    getInitialState(options?: InitialStateOptions): RouterState;
    resetChildRoute(routeable: RouteableReducer): RouteableState;
    reconcile(routerState: RouterState, mountedNode: MountedNode): void;
}
